unit u_translation;

{$mode objfpc}{$H+}

interface

uses gettext, translations, u_constant, u_util,
  Classes, SysUtils;

procedure GetDefaultLanguage(var buf1,buf2: string);
function Translate(lang : string = ''):string;

resourcestring
  rsLanguage = 'Internal language';
  rsDocumentatio = 'en/documentation/start.html';
  rsdeg = 'd';
  rsmin = 'm';
  rssec = 's';
  rsHour = 'Hour';
  rsMinute = 'Minute';
  rsSecond = 'Second';
  rsDay = 'Day';
  rsMonth = 'Month';
  rsYear = 'Year';
  rsJulianYear = 'Julian Year';
  rsTropicalYear = 'Tropical Year';
  rsSiderealDay = 'Sidereal Day';
  rsSynodicMonth = 'Synodic Month';
  rsSaros = 'Saros';
  rsSetDateAndTi = 'Set date and time';
  rsSetObservato = 'Set observatory location';
  rsConfigureThe = 'Configure the program';
  rsEquatorialCo = 'Equatorial Coordinate';
  rsAltAzCoordin = 'Alt-Az Coordinate';
  rsEclipticCoor = 'Ecliptic Coordinate';
  rsGalacticCoor = 'Galactic Coordinate';
  rsMirrorHorizo = 'Mirror Horizontally';
  rsMirrorVertic = 'Mirror Vertically';
  rsRotateRight = 'Rotate Right';
  rsRotateLeft = 'Rotate Left';
  rsShowAllSky = 'Show All Sky';
  rsNorth = 'North';
  rsSouth = 'South';
  rsEast = 'East';
  rsWest = 'West';
  rsZenith = 'Zenith';
  rsCreateANewCh = 'Create a new chart';
  rsOpenAChart = 'Open a chart';
  rsSaveTheCurre = 'Save the current chart';
  rsPrintTheChar = 'Print the chart';
  rsNightVisionC = 'Night vision color';
  rsCascade = 'Cascade';
  rsTileVertical = 'Tile Vertically';
  rsUndoLastChan = 'Undo Last Change';
  rsRedoLastChan = 'Redo Last Change';
  rsZoomIn = 'Zoom In';
  rsZoomOut = 'Zoom Out';
  rsSetFOV = 'Set FOV';
  rsAdvancedSear = 'Advanced Search';
  rsPosition = 'Position';
  rsObjectList = 'Object List';
  rsEphemerisCal = 'Ephemeris Calendar';
  rsDecrementTim = 'Decrement Time';
  rsNow = 'Now';
  rsIncrementTim = 'Increment Time';
  rsConnectTeles = 'Connect Telescope';
  rsSlew = 'Slew';
  rsSync = 'Sync';
  rsShowStars = 'Show Stars';
  rsShowNebulae = 'Show Deep Sky Objects';
  rsShowLines = 'Show Lines';
  rsShowPictures = 'Show Pictures';
  rsGetDSSImage = 'Get DSS Image';
  rsChangePictur = 'Change pictures display';
  rsShowPlanets = 'Show Planets';
  rsShowAsteroid = 'Show Asteroids';
  rsShowComets = 'Show Comets';
  rsShowMilkyWay = 'Show Milky Way';
  rsShowCoordina = 'Show Coordinate Grid';
  rsAddEquatoria = 'Add Equatorial Grid';
  rsShowConstell = 'Show Constellation Line';
  rsShowConstell2 = 'Show Constellation Limit';
  rsShowGalactic = 'Show Galactic Equator';
  rsShowEcliptic = 'Show Ecliptic';
  rsShowMark = 'Show Mark';
  rsShowLabels = 'Show Labels';
  rsShowObjectBe = 'Show Object below the horizon';
  rsSkyBackgroun = 'Sky Background Color';
  rsLinkAllChart = 'Link All Chart';
  rsNoObjectToLo = 'No object to lock on';
  rsChangeDrawin = 'Change Drawing Mode';
  rsFile = 'File';
  rsNewChart = 'New Chart';
  rsOpen = 'Open';
  rsSaveAs = 'Save As...';
  rsSaveImage = 'Save Image...';
  rsCloseChart = 'Close Chart';
  rsCalendar = 'Calendar';
  rsPrint = 'Print';
  rsExit = 'Exit';
  rsEdit = 'Edit';
  rsCopy = 'Copy';
  rsUndo = 'Undo';
  rsRedo = 'Redo';
  rsSetup = 'Setup';
  rsConfiguratio = 'Configuration';
  rsSaveConfigur = 'Save Configuration Now';
  rsSaveConfigur2 = 'Save Configuration On Exit';
  rsDateTime = 'Date / Time';
  rsObservatory = 'Observatory';
  rsLines = 'Lines';
  rsLabels = 'Labels';
  rsFonts = 'Fonts';
  rsPictures = 'Pictures';
  rsShowHideDSSI = 'Show/Hide DSS image';
  rsCatalog = 'Catalog';
  rsView = 'View';
  rsFullScreen = 'Full Screen';
  rsNightVision = 'Night Vision';
  rsToolBar = 'Tool Bar';
  rsAllToolsBar = 'All Tools Bar';
  rsMainBar = 'Main Bar';
  rsObjectBar = 'Object Bar';
  rsLeftBar = 'Left Bar';
  rsRightBar = 'Right Bar';
  rsStatusBar = 'Status Bar';
  rsScrollBar = 'Scroll Bar';
  rsServerInform = 'Server Information';
  rsChart = 'Chart';
  rsProjection = 'Projection';
  rsTransformati = 'Transformation';
  rsFieldOfVisio = 'Field of Vision';
  rsViewHorizon = 'View Horizon';
  rsShowObjects = 'Show Objects';
  rsLinesGrid = 'Lines / Grid';
  rsBelowTheHori = 'Below the horizon';
  rsTelescope = 'Telescope';
  //rsConnect = 'Connect';
  rsControlPanel = 'Control Panel';
  rsWindow = 'Window';
  rsTileHorizont = 'Tile Horizontally';
  rsMaximize = 'Maximize';
  rsHelp = 'Help';
  rsHelpContents = 'Help contents';
  rsSkychartHome = 'Skychart Homepage';
  rsMailList = 'MailList';
  rsReportAProbl = 'Report a problem';
  rsAbout = 'About';
  rsResetAllLabe = 'Reset All Labels';
  rsBlueMagnitud = 'Blue Magnitude';
  rsVisualMagnit = 'Visual Magnitude';
  rsRedMagnitude = 'Red Magnitude';
  rsMagnitude = 'Magnitude';
  rsMagnitudeTyc = 'Magnitude Tycho BT';
  rsMagnitudeTyc2 = 'Magnitude Tycho VT';
  rsColorIndex = 'Color Index';
  rsSpectralClas = 'Spectral Class';
  rsAnnualProper = 'Annual Proper Motion';
  rsClass = 'Class';
  rsNote = 'Note';
  rsTypeOfVariab = 'Type of Variability';
  rsPeriod = 'Period';
  rsMagnitudeBan = 'Magnitude Band';
  rsPhotographic = 'Photographic Plate';
  rsMultipleFlag = 'Multiple Flag';
  rsFieldNumber = 'Field Number';
  rsMagnitudeErr = 'Magnitude Error';
  rsCorrelated = 'Correlated';
  rsDimension = 'Dimension';
  rsConstellatio = 'Constellation';
  rsSurfaceBrigh = 'Surface Brightness';
  rsDescription = 'Description';
  rsRadialVeloci = 'Radial Velocity';
  rsSurface = 'Surface';
  rsBrightness = 'Brightness';
  rsTrumplerClas = 'Trumpler Class';
  rsDistance = 'Distance';
  rsBrightestSta = 'Brightest Star Magnitude';
  rsNumberOfStar = 'Number of Stars';
  rsAge = 'Age';
  rsTotalRadius = 'Total Radius';
  rsHalfMassRadi = 'Half-Mass Radius';
  rsCoreRadius = 'Core Radius';
  rsHbetaMagnitu = 'Hbeta Magnitude';
  rsCentralStarB = 'Central Star B Magnitude';
  rsCentralStarV = 'Central Star V Magnitude';
  rsDiameter = 'Diameter';
  rsIlluminatedF = 'Illuminated Fraction';
  rsPhase = 'Phase';
  rsEstimatedTai = 'Estimated tail length';
  rsSolarElongat = 'Solar Elongation';
  rsSolarDistanc = 'Solar Distance';
  rsOpenCluster = 'Open Cluster';
  rsGlobularClus = 'Globular Cluster';
  rsGalaxy = 'Galaxy';
  rsBrightNebula = 'Bright Nebula';
  rsNebula = 'Deep Sky Object';
  rsPlanetaryNeb = 'Planetary Nebula';
  rsClusterAndNe = 'Cluster and Nebula';
  rsStar = 'Star';
  rsDoubleStar = 'Double Star';
  rsTripleStar = 'Triple Star';
  rsVariableStar = 'Variable Star';
  rsAsterism = 'Asterism';
  rsKnot = 'Knot';
  rsUnknowObject = 'Unknow object';
  rsPlateDefect = 'Plate Defect';
  rsPlanet = 'Planet';
  rsAsteroid = 'Asteroid';
  rsComet = 'Comet';
  rsExternalCata = 'External catalog object';
  rsFlamsteedNum = 'Flamsteed Number';
  rsBayerLetter = 'Bayer Letter';
  rsParallax = 'Parallax';
  rsPositionAngl = 'Position Angle';
  rsProperMotion = 'Proper Motion in Right ascension';
  rsProperMotion2 = 'Proper Motion in Declination';
  rsMagnitudeAtM = 'Magnitude at maxima';
  rsMagnitudeAtM2 = 'Magnitude at minima';
  rsEpochOfMaxim = 'Epoch of maxima';
  rsRiseTime = 'Rise time';
  rsComponent1Ma = 'Component 1 Magnitude';
  rsComponent2Ma = 'Component 2 Magnitude';
  rsSeparation = 'Separation';
  rsDate = 'Date';
  rsDegrees = 'degrees';
  rsMinutes = 'minutes';
  rsLightYears = 'light years';
  rsPoleInclinat = 'Pole inclination';
  rsSunInclinati = 'Sun inclination';
  rsCentralMerid = 'Central meridian';
  rsGRSTransit = 'GRS transit';
  rsLibrationInL = 'Libration in latitude';
  rsLibrationInL2 = 'Libration in longitude';
  rsAzimuth = 'Azimuth';
  rsAltitude = 'Altitude';
  rsRise = 'Rise';
  rsCulmination = 'Culmination';
  rsSet = 'Set';
  rsCircumpolar = 'Circumpolar';
  rsInvisibleAtT = 'Invisible at this latitude';
  rsDistanceToTh = 'Distance to the last object';
  rsLocalSideral = 'Local Sideral Time';
  rsHourAngle = 'Hour Angle';
  rsPlanetarySat = 'Planetary satellite';
  rsUniversalTim = 'Universal Time';
  rsVisibilityFo = 'Visibility for observatory';
  rsFrom = 'From';
  rsTo = 'to';
  rsOffset = 'Offset';
  rsTooManyOpenW = 'Too many open window, please close some chart.';
  rsDoYouWantToS = 'Do you want to save the program setting now?';
  rsErrorPleaseC = 'Error! Please check the database parameters.';
  rsComputeAster = 'Compute asteroid data for this month';
  rsErrorPleaseC2 = 'Error! Please check the database parameters and load the '
    +'comete data file.';
  rsNotFoundMayb = '%s Not found!%sMaybe the catalog is not installed, or '
    +'wrong path in catalog setting.';
  rsUnlockChart = 'Unlock Chart';
  rsLockOn = 'Lock on %s';
  rsNotFoundInAn = '%s  Not found in any installed catalog index.';
  rsDisconnectTe = 'Disconnect Telescope';
  rsSocketError = 'Socket error %s.  %s';
  rsDifferentTha = '%s (different than configured port, maybe busy or other '
    +'error.)';
  rsListenOnPort = 'Listen on port: %s';
  rsTCPIPService = 'TCP/IP service not available.';
  rsConnectedToS = 'Connected to SQL database %s';
  rsSQLDatabaseN = 'SQL database not available.';
  rsInitializeDa = 'Initialize Database';
  rsNotConnected = '%s not connected.';
  rsConnectedFro = '%s connected from %s, using chart %s, connect time:%s';
  rsOK = 'OK';
  rsCancel = 'Cancel';
  rsAz = 'Az';
  rsAlt = 'Alt';
  rsRA = 'RA';
  rsDE = 'DE';
  rsFOV = 'FOV';
  rsRotation = 'Rotation';
  rsEquatorialCo2 = 'Equatorial coordinates, equinox: %s';
  rsAltAZCoord = 'Alt/AZ Coord. ';
  rsGalacticCoor2 = 'Galactic Coord.';
  rsLII = 'LII';
  rsBII = 'BII';
  rsL = 'L';
  rsB = 'B';
  rsFilter = 'Filter ->';
  rsMercury = 'Mercury';
  rsVenus = 'Venus';
  rsMars = 'Mars';
  rsJupiter = 'Jupiter';
  rsSaturn = 'Saturn';
  rsUranus = 'Uranus';
  rsNeptune = 'Neptune';
  rsPluto = 'Pluto';
  rsSun = 'Sun';
  rsMoon = 'Moon';
  rsSatRing = 'Sat.Ring';
  rsObjectName = 'Object Name';
  rsSearchFor = 'Search for';
  rsFind = 'Find';
  rsPleaseEnterA = 'Please enter an object identifier.';
  rsNotFound = '%s not found';
  rsPleaseCheckY = 'Please check your Internet connection and the URL '
    +'definition';
  rsError = 'Error';
  rsPleaseConfig = 'Please configure your DSS file path first.';
  rsFieldTooWidt = 'Field too width! Maximum is %s';
  rsEstimatedFil = 'Estimated file size: %sMB %sDo you want to continue ?';
  rsPleaseMountR = 'Please mount RealSky CD number';
  rsInDrive = 'in drive';
  rsListOfAvaila = 'List of available plates';
  rsPlateIdDateE = 'Plate Id.    Date   Exp.  Margin  CD  Observatory';
  rsManualTelesc = 'Manual Telescope';
  rsRATurns = 'RA turns: ';
  rsDECTurns = 'DEC turns: ';
  rsClose = 'Close';
  rsCenterObject = 'Center Object';
  rsNeighbor = 'Neighbor';
  rsSelectAll = 'Select All';
  rsTCPIPConnect = 'TCP/IP Connection';
  rsRefresh = 'Refresh';
  rsAutoRefresh = 'AutoRefresh';
  rsSearch = 'Search';
  rsSortByRA = 'Sort by RA';
  rsSave = 'Save';
  rsProgressMess = 'Progress Messages';
  rsCloseConnect = 'Close Connection';
  rsTimeZone = 'Time Zone';
  rsDateFrom = 'Date from';
  rsAt = 'at';
  rsBy = 'by';
  rsDays = 'days';
  rsSaveToFile = 'Save to File';
  rsResetChart = 'Reset Chart';
  rsTwilight = 'Twilight';
  rsSolarEclipse = 'Solar Eclipses';
  rsLunarEclipse = 'Lunar Eclipses';
  rsArtificialSa = 'Artificial Satellites';
  rsChart2 = 'chart :';
  rsLimitingMagn = 'Limiting magnitude, list :';
  rsMagn = 'Magn.';
  rsDiam = 'Diam.';
  rsIllum = 'Illum.';
  rsMorningTwili = 'Morning twilight';
  rsEveningTwili = 'Evening twilight';
  rsAstronomical = 'Astronomical';
  rsNautical = 'Nautical';
  rsMorning = 'Morning';
  rsEvening = 'Evening';
  rsElong = 'Elong.';
  rsWarningCalcu = 'Warning! Calculation of';
  rsDatesMayTake = 'dates may take a long time. Do you want to continue ?';
  rsUT = 'UT';
  rsMax = 'Max.';
  rsType = 'Type';
  rsGamma = 'Gamma';
  rsGreatest = 'Greatest';
  rsEclipse = 'Eclipse';
  rsLatitude = 'Latitude';
  rsLongitude = 'Longitude';
  rsSunAlt = 'Sun alt.';
  rsPathWidth = 'Path Width';
  rsDuration = 'Duration';
  rsPenumbra = 'Penumbra';
  rsUmbra = 'Umbra';
  rsSemi = 'Semi';
  rsPartial = 'Partial';
  rsTotal = 'Totality';
  rsSatellite = 'Satellite';
  rsRange = 'Range';
  rsDir = 'Dir';
  rsCoord = 'Coord.';
  rsMap = 'Map';
  rsPrinter = 'Printer:';
  rsResolution = 'Resolution:';
  rsSelectTheSys = 'Select the system printer and options you want to use';
  rsPrinterSetup = 'Printer Setup';
  rsRasterResolu = 'Raster Resolution';
  rsCommandToUse = 'Command to use to process the file.';
  rsPathToSaveTh = 'Path to save the file :';
  rsPrintMethod = 'Print method';
  rsCommandFound = 'Command found OK.';
  rsCommandNotFo = 'Command not found!';
  rsColor = 'Color';
  rsOrientation = 'Orientation';
  rsPageMarginIn = 'Page Margin in millimeter';
  rsLeft = 'Left';
  rsRight = 'Right';
  rsTop = 'Top';
  rsBottom = 'Bottom';
  rsNoMargin = 'No Margin';
  rsDefaultMargi = 'Default Margin';
  rsCentre = 'Centre';
  rsZoomCentre = 'Zoom + Centre';
  rsZoomCentre2 = 'Zoom - Centre';
  rsNewFinderCir = 'New Finder Circle';
  rsRemoveLastCi = 'Remove Last Circle';
  rsRemoveAllCir = 'Remove All Circles';
  rsNewLabel = 'New Label';
  rsRemoveLastLa = 'Remove Last Label';
  rsRemoveAllLab = 'Remove All Labels';
  rsAbortSlew = 'Abort Slew';
  rsCreatePostsc = 'Create postscript chart. Please wait...';
  rsSendChartToP = 'Send chart to printer.';
  rsCreateRaster = 'Create raster chart at %s dpi. Please wait...';
  rsOpenTheBitma = 'Open the bitmap.';
  rsAbout2 = 'About %s';
  rsRATurns2 = '%sRA turns:';
  rsCCW = '%sCCW';
  rsDECTurns2 = '%sDEC turns:';
  rsCW = '%sCW';
  rsAzTurns = '%sAz turns:';
  rsAltTurns = '%sAlt turns:';
  rsDesc = 'desc:';
  rsEcliptic = 'Ecliptic';
  rsGalactic = 'Galactic';
  rsOther = 'Other';
  rsTelescopeNot = 'Telescope not connected';
  rsPleaseConfir = 'Please confirm that the telescope is centered to %s';
  rsTelescope2 = 'Telescope: %s';
  rsSkyCharts = 'Sky Charts';
  rsThisProgramI = 'This program is free software; you can redistribute it '
    +'and/or modify it under the terms of the GNU General Public License';
  rsLabel = 'Label:';
  rsType2 = 'Type:';
  rsMultipleStar = 'Multiple Star';
  rsSolarSystem = 'Solar System';
  rsOtherLabel = 'Other label';
  rsChartInforma = 'Chart Information';
  rsIndicateHere = 'Indicate here how to compute the require value from the '
    +'data stored in the catalog text file.';
  rsSelectTheTyp = 'Select the type of object in your catalog';
  rsInputCatalog = 'Input Catalog files';
  rsCatalogShort = 'Catalog short name';
  rsCatalogLongN = 'Catalog long name';
  rsForALargeCat = 'For a large catalog always select Binary. For a small '
    +'dataset that change frequently select Text, this let you edit the file '
    +'and see the result immediatly on the chart without the need to rerun '
    +'this utility.';
  rsCatalogType = 'Catalog type';
  rsOutputCatalo = 'Output Catalog Type';
  rsGeneralCatal = 'General catalog options';
  rsDefaultNebul = 'Default Nebulae parameters';
  rsDimensionAnd = 'Dimension and Units';
  rsObjectType = 'Object type';
  rsRecognizeUni = 'Recognize Units or Object type from the file:';
  rsUsefulToRepr = '(useful to represent a flux)';
  rsDegree = 'Degree';
  rsLogarithmicS = 'Logarithmic scale';
  rsGalaxyCluste = 'Galaxy Cluster';
  rsDarkNebula = 'Dark Nebula';
  rsNonExistant = 'Non Existant';
  rsUnknow = 'Unknow';
  rsCircle = 'Circle';
  rsSquare = 'Square';
  rsLosange = 'Losange';
  rsEditObjectTy = 'Edit Object Types';
  rsEditUnits = 'Edit Units';
  rsDefaultOutli = 'Default Outline parameters';
  rsLineWidth = 'Line width ';
  rsEditLineOper = 'Edit Line operation';
  rsEditColor = 'Edit Color';
  rsDrawingType = 'Drawing Type';
  rsClosedContou = 'Closed contour';
  rsRAOptions = 'RA options';
  rsDECOptions = 'DEC options';
  rsCoordinatesE = 'Coordinates Equinox';
  rsMaximumMagni = 'Maximum magnitude';
  rsPositionEpoc = 'Position Epoch';
  rsFirstChar = 'First Char';
  rsLength = 'Length';
  rsSelectTheFie = 'Select the fields to use and their position in the text '
    +'file';
  rsLabel2 = 'Label';
  rsUseThisField = 'Use this field as an Alternate Name';
  rsAdvanced = 'Advanced';
  rsOutputCatalo2 = 'Output catalog options';
  rsNumberOfFile = 'Number of files';
  rsOutputDirect = 'Output Directory';
  rsAppendToAnEx = 'Append to an existing catalog ';
  rsSearchIndex = 'Search Index';
  rsCreateASearc = 'Create a search index file';
  rsAddTheAltern = 'Add the alternate names to the index';
  rsPrefixTheAlt = 'Prefix the alternate names with their label';
  rsIndicateTheS = 'Indicate the string identifier for each type of object :';
  rsReturn = 'Return';
  rsIndicateHowT = 'Indicate how to recognize the object size unit :';
  rsIndicateTheS2 = 'Indicate the string for each draw operation';
  rsIndicateTheS3 = 'Indicate the string for each color';
  rsClickToChang = 'Click to change the color ';
  rsPrev = '<<   Prev';
  rsNext = 'Next   >>';
  rsBuildCatalog = 'Build Catalog';
  rsLoadProject = 'Load project';
  rsSaveProject = 'Save Project';
  rsCatalogStrin = 'Catalog string';
  rsDarkNebula2 = 'Dark nebula';
  rsObjectSizeUn = 'Object size unit';
  rsLineOperatio = 'Line operation';
  rsStartOfObjec = 'Start of object';
  rsEndOfObject = 'End of object';
  rsDrawLine = 'Draw line';
  rsPleaseIndica = 'Please indicate a catalog short name';
  rsPleaseIndica2 = 'Please indicate a catalog long name';
  rsIsCoordinate = 'Is coordinates epoch really %s ?';
  rsRequiredFiel = 'Required field missing !';
  rsAbortedByUse = 'Aborted by user';
  rsConvertCatal = 'Convert catalog file %s';
  rsSortingTheIn = 'Sorting the index file ';
  rsCreateHeader = 'Create header';
  rsCreateFiles = 'Create files';
  rsConvertCatal2 = 'Convert catalog files';
  rsCloseFiles = 'Close files';
  rsSortingFiles = 'Sorting files by magnitude';
  rsSomeRecordsW = 'Some records where rejected, see file %sreject.txt for '
    +'details';
  rsPleaseIndica3 = 'Please indicate the directory where the catalog must to '
    +'be build';
  rsWARNINGYouHa =
      'WARNING !%sYou have choose to append the data to an '
    +'existing catalog.%sThe existing catalog and index must be exactly of '
    +'the same format, otherwise it will be corrupted.%sIt is a good idea to '
    +'backup the actual files before this operation.%sDo you want to continue ?';
  rsDateTime2 = 'Date/Time';
  rsTimeSimulati = 'Time Simulation';
  rsHorizon = 'Horizon';
  rsChartCoordin = 'Chart, Coordinates';
  rsObjectFilter = 'Object Filter';
  rsGridSpacing = 'Grid Spacing';
  rsCdCStars = 'CdC Stars';
  rsCdCNebulae = 'CdC Deep Sky';
  rsObsolete = 'Obsolete';
  rsDisplay = 'Display';
  rsDisplayColou = 'Display colour';
  rsDeepSkyObjec = 'Deep sky object colour';
  rsFinderCircle = 'Finder circle (Eyepiece)';
  rsFinderRectan = 'Finder rectangle (CCD)';
  rsObject = 'Object';
  rsBackground = 'Background';
  rsDSSRealSky = 'DSS RealSky';
  rsSystem = 'System';
  rsServer = 'Server';
  rsInternet = 'Internet';
  rsProxy = 'Proxy';
  rsOrbitalEleme = 'Orbital Elements';
  rsOnlineDSSPic = 'Online DSS pictures';
  rsApplyChangeT = 'Apply Change To All Chart';
  rsStarsAndNebu = 'Stars and Deep Sky catalogs prepared with ';
  rsAdd = 'Add';
  rsDelete = 'Delete';
  rsCDCStarsCata = 'CDC Stars Catalog Setting';
  rsPm = 'pm';
  rsMin2 = 'min';
  rsMax2 = 'max';
  rsFilesPath = 'Files Path';
  rsStars = 'Stars';
  rsVariables = 'Variables';
  rsDoubles = 'Doubles';
  rsBrightStars = 'Bright stars';
  rsShowIRVariab = 'Show IR variables';
  rsCDCNebulaeCa = 'CDC Deep Sky Catalog Setting';
  rsNebulae = 'Deep Sky Objects';
  rsGalaxies = 'Galaxies';
  rsPlanetaryNeb2 = 'Planetary nebulae';
  rsGeneral = 'General';
  rsUseOnlyCatal = 'Use only the catalog from the same group';
  rsDefault = 'Default';
  rsCDCObsoleteC = 'Obsolete CDC Catalog (but you can still use them)';
  rsReplacedBy = 'Replaced by';
  rsCdCFormatPre = 'CdC format, prefere the compact version';
  rsNotAvailable = 'Not available';
  rsFovNumber = 'fov number:';
  rsApply = 'Apply';
  rsCat = 'Cat.';
  rsMin3 = 'Min.';
  rsPath = 'Path';
  rsChartSetting = 'Chart Setting';
  rsYears = 'years';
  rsStarsProperM = 'Stars proper motion options (if available in the catalog)';
  rsUseTheProper = 'Use the proper motion to correct the position for the '
    +'given epoch';
  rsDrawALineTha = 'Draw a line that represent the proper motion for the next ';
  rsEquinox = 'Equinox:';
  rsChartCoordin2 = 'Chart Coordinate System';
  rsNutationAber = 'Nutation ,  Aberration';
  rsFieldOfVisio3 = 'Field of Vision Setting';
  rsProjectionSe = 'Projection Setting';
  rsObjectFilter2 = 'Object Filter Setting';
  rsStarsFilter = 'Stars Filter';
  rsFilterStars = 'Filter stars ';
  rsFieldOfVisio5 = 'Field of vision number :';
  rsLimitingMagn2 = 'Limiting magnitude :';
  rsNakedEyeRefe = 'Naked eye reference';
  rsAutomatic = 'Automatic';
  rsNebulaeFilte = 'Deep Sky Filter';
  rsFilterNebula = 'Filter Deep Sky Objects';
  rsHideObjectWi = 'Hide object wider than';
  rsLimitingSize = 'Limiting Size (arcminutes) :';
  rsGridSetting = 'Grid Setting';
  rsDegreeGridSp = 'Degree Grid Spacing';
  rsHourGridSpac = 'Hour Grid Spacing';
  rsObjectListSe = 'Object List Setting';
  rsTypeOfObject = 'Type of object to add to the list';
  rsSolarSystemO = 'Solar System object';
  rsStarDisplay = 'Star Display';
  rsNebulaDispla = 'Deep Sky Objects Display';
  rsStarDisplayP = 'Star Display  Properties';
  rsFaintStarsSi = 'Faint Stars Size ';
  rsContrast = 'Contrast';
  rsColorSaturat = 'Color saturation';
  rsIncrementFor = 'Increment for Bright Stars';
  rsNakedEye = 'Naked Eye';
  rsHighColor = 'High Color';
  rsBlackWhite = 'Black/White';
  rsStarColourBV = 'Star colour (B-V) :';
  rsCoordGrid = 'Coord. Grid';
  rsEqGrid = 'Eq. Grid';
  rsOrbit = 'Orbit';
  rsBoundary = 'Boundary';
  rsEyepiece = 'Eyepiece';
  rsMiscLines = 'Misc. Lines';
  rsMilkyWay = 'Milky Way';
  rsStandardColo = 'Standard  Color';
  rsTheme = 'Theme';
  rsNightVisionB = 'Night Vision Button';
  rsDefaultButto = 'Default Button';
  rsDeepSkyColou = 'Deep-sky colour';
  rsUseAPresetCo = 'Use a preset colour scheme :';
  rsChooseColour = 'Choose colours for object type';
  rsSupernovaRem = 'Supernova remnant';
  rsPlanetaryNeb3 = 'Planetary nebula';
  rsEmissionNebu = 'Emission nebula';
  rsReflectionNe = 'Reflection nebula';
  rsGalaxyCluste2 = 'Galaxy cluster';
  rsQuasar = 'Quasar';
  rsGravitationa = 'Gravitational lens';
  rsNonExistentU = 'Non-existent/unknown';
  rsFill = 'Fill?';
  rsAdjustColour = 'Adjust colour brightness';
  rsLowSurfaceBr = 'Low surface brightness';
  rsHighSurfaceB = 'High surface brightness';
  rsFainter = 'Fainter';
  rsBrighter = 'Brighter';
  rsSkyColour = 'Sky Colour';
  rsDayTime = 'Day Time';
  rsAstronomical2 = 'Astronomical Twilight';
  rsDefaultColor = 'Default color';
  rsShowGridLabe = 'Show Grid Label';
  rsConstellatio2 = 'Constellation Figures';
  rsConstellatio3 = 'Constellation Figure File Name : ';
  rsShowConstell3 = 'Show Constellation Figure';
  rsLine1 = 'Line';
  rsDash1 = 'Dash';
  rsDot1 = 'Dot';
  rsDashDot1 = 'Dash Dot';
  rsDashDotDot1 = 'Dash Dot Dot';
  rsConstellatio4 = 'Constellation Boundaries';
  rsConstellatio5 = 'Constellation Boundary File Name : ';
  rsShowConstell4 = 'Show Constellation Boundary';
  rsFillMilkyWay = 'Fill Milky Way';
  rsStarLabel = 'Star Label';
  rsConstellatio6 = 'Constellation Label';
  rsDisplayTheLa = 'Display the labels';
  rsDisplayTheCh = 'Display the chart information in the menu bar.';
  rsLabelObject = 'Label Object';
  rsMagnitudeDif = 'Magnitude difference';
  rsSize = 'Size';
  rsConstellatio7 = 'Constellation name';
  rsCoordinatesG = 'Coordinates Grid';
  rsLegend = 'Legend';
  rsScreenAndSta = 'Screen and Status Bar';
  rsPrinterLegen = 'Printer legend';
  rsModify = 'Modify';
  rsGreekSymbol = 'Greek symbol';
  rsNo = 'No.';
  rsMarkTheChart = 'Mark the chart center ';
  rsWidth = 'Width';
  rsHeight = 'Height';
  rsHTTPProxy = 'HTTP Proxy';
  rsUseHTTPProxy = 'Use HTTP Proxy';
  rsProxyHost = 'Proxy host';
  rsProxyPort = 'Proxy port';
  rsUserName = 'User Name';
  rsPassword = 'Password';
  rsFTP = 'FTP ';
  rsAnonymousPas = 'Anonymous password';
  rsFTPPassiveMo = 'FTP Passive Mode';
  rsCometElement = 'Comet elements in MPC format (one URL by line) ';
  rsAsteroidElem = 'Asteroid elements in MPC format (one URL by line)';
  rsBrightNEO = 'Bright + NEO + TNO';
  rsMPCHttp = 'MPC Http';
  rsMPCFtp = 'MPC Ftp';
  rsFirst5000 = 'First 5000';
  rsOnlineDSS = 'Online DSS';
  rsOnlinePictur = 'Online pictures servers';
  rsName = 'Name';
  rsURL = 'URL';
  rsSec2 = 'Sec.';
  rsMeters = 'Meters';
  rsLoad = 'Load';
  rsObservatoryD = 'Observatory Database';
  rsKm = 'Km.';
  rsDownloadCoun = 'Download country details';
  rsUpdate1 = 'Update';
  rsVicinity = 'Vicinity';
  rsAtmosphericR = 'Atmospheric Refraction';
  rsPressureMill = 'Pressure (millibar)';
  rsTemperatureC = 'Temperature (Celsius)';
  rsWantToTrackA = 'Want to track an object before it rise ?';
  rsLocalHorizon = 'Local Horizon';
  rsLocalHorizon2 = 'Local Horizon File Name : ';
  rsDisplayTheLo = 'Display the local horizon line';
  rsDepressionOf = 'Depression of the visible horizon';
  rsYouLiveOnABi = 'If you observe from a big mountain, the horizon line will be lower than would be at sea level.';
  rsDrawTheAppar = 'Draw the apparent depressed horizon line';
  rsUpdateOrAddT = 'Update or add the current location to the database ?';
  rsUpdatedSucce = 'Updated successfully!';
  rsDeleteTheCur = 'Delete the current location from the database ?';
  rsDeletedSucce = 'Deleted successfully!';
  rsThisActionRe = 'This action replace all the database content for the '
    +'country %s using fresh data from NGA and GNIS.%sAll your editing for '
    +'this country will be lost except the location you added with a new name '
    +'that will be kept.%sDo you want to continue ?';
  rsCancel2 = 'Cancel %s';
  rsCancelWrongZ = 'Cancel, wrong zip file ?? %s';
  rsObjects = 'Objects';
  rsDisplayImage = 'Display image of cataloged objects';
  rsImageDirecto = 'Image Directory';
  rsThereAreCata = 'There are %s catalogued images';
  rsScanDirector = 'Scan directory';
  rsLuminosity = 'Luminosity';
  rsReset = 'Reset';
  rsShowObjectPi = 'Show object pictures on the chart';
  rsBackgroundPi = 'Background Picture';
  rsFITSFile = 'FITS File';
  rsShowThisPict = 'Show this picture';
  rsAuxiliaryFil = 'Auxiliary files';
  rsDataFilesCDr = 'Data Files, CDrom';
  rsTemporaryFil = 'temporary file';
  rsPixels = 'pixels';
  rsMBytes = 'MBytes';
  rsRealSkyNorth = 'RealSky North';
  rsRealSkySouth = 'RealSky South';
  rs102CDDSS = '102 CD DSS';
  rsUseSubsampli = 'Use subsampling to limit image size to';
  rsSelectPlateF = 'Select plate from list';
  rsUseOnlineDSS = 'Use online DSS instead of RealSky';
  rsDEC = 'DEC';
  rsNoPicture = 'No picture';
  rsSolarSystemS = 'Solar System Setting';
  rsDataFiles = 'Data Files :';
  rsPlanetsSetti = 'Planets Setting';
  rsJupiterGRSLo = 'Jupiter GRS longitude :';
  rsShowPlanetOn = 'Show Planet on the Chart';
  rsDrawPlanetAs = 'Draw Planet As';
  rsShowEarthSha = 'Show Earth Shadow  (Lunar eclipses)';
  rsImageOptions = 'Image Options';
  rsUseXplanet = 'Use Xplanet';
  rsTransparentL = 'Transparent line mode (occultation)';
  rsGeneralSetti = 'General Setting';
  rsDoNotTakeAcc = 'Do not take account of comet fainter than magnitude';
  rsMagnitudeFai = 'magnitude fainter than the stars.';
  rsShowCometsOn = 'Show comets on the chart';
  rsDatabaseSett = 'Database setting...';
  rsLoadMPCFile = 'Load MPC File';
  rsMessages = 'Messages:';
  rsOrUseALocalF = 'Or use a local file :';
  rsLoadMPCForma = 'Load MPC format file';
  rsDownloadLate = 'Download latest orbital elements';
  rsDownload = 'Download';
  rsLoadFile = 'Load file';
  rsDataMaintena = 'Data Maintenance';
  rsDeleteMPCDat = 'Delete MPC data selectively';
  rsQuickDelete = 'Quick Delete';
  rsQuicklyDelet = 'Quickly delete all comet related data';
  rsAddASingleEl = 'Add a single element to the database. All fields are '
    +'mandatory.';
  rsDesignation = 'Designation';
  rsHAbsoluteMag = 'H absolute magnitude';
  rsGSlopeParame = 'G slope parameter';
  rsEpochJD = 'Epoch (JD)';
  rsPerihelionDa = 'Perihelion date';
  rsArgumentOfPe = 'Argument of perihelion';
  rsLongitudeAsc = 'Longitude ascending Node';
  rsInclination = 'Inclination';
  rsEccentricity = 'Eccentricity';
  rsPerihelionDi = 'Perihelion distance';
  rsEquinox2 = 'Equinox';
  rsDoNotTakeAcc2 = 'Do not take account of asteroid fainter than magnitude';
  rsShowAsteroid3 = 'Show asteroids on the chart';
  rsOptions = 'Options';
  rsAsteroidsFro = 'Asteroids from the file';
  rsOnlyNumbered = 'Only numbered asteroids';
  rsHaltAfter100 = 'Halt after 1000 errors';
  rsLoadOnlyTheF = 'Load only the first ';
  rsPrepareMonth = 'Prepare Monthly Data';
  rsPrepareData = 'Prepare data ';
  rsStartMonth = 'Start Month';
  rsNumberOfMont = 'Number of Month';
  rsCompute = 'Compute';
  rsQuicklyDelet2 = 'Quickly delete all asteroid related data';
  rsDeleteMonthl = 'Delete Monthly data ';
  rsDeleteMonthl2 = 'Delete Monthly data older than ';
  rsMeanAnomaly = 'Mean anomaly';
  rsSemimajorAxi = 'Semimajor Axis';
  rsReference = 'Reference';
  rsPleaseConfig2 = 'Please configure the orbital element URL!';
  rsDownload2 = 'Download %s';
  rsToUseThisNew = 'To use this new data you must now compute the Monthly Data';
  rsNoAsteroidDa = 'No Asteroid data found!%sPlease load a MPC file first.';
  rsYouAreNowRea = 'You are now ready to display the asteroid for this time '
    +'period.';
  rsSystemSettin = 'System Setting';
  rsMySQLDatabas = 'MySQL Database';
  rsDBName = 'DB Name:';
  rsHostName = 'Host Name:';
  rsPort = 'Port:';
  rsUserid = 'Userid:';
  rsSqliteDataba = 'Sqlite Database';
  rsDatabaseFile = 'Database file: ';
  rsDirectory = 'Directory';
  rsProgramData = 'Program Data ';
  rsPersonalData = 'Personal data';
  rsCheck = 'Check';
  rsCreateDataba = 'Create Database';
  rsDropDatabase = 'Drop Database';
  rsCometSetting = 'Comet Setting';
  rsAsteroidSett = 'Asteroid Setting';
  rsDatabaseType = 'Database Type';
  rsDesktopEnvir = 'Desktop environment';
  rsURLLaunchCom = 'URL launch command';
  rsTCPIPServer = 'TCP/IP Server';
  rsServerIPInte = 'Server IP Interface :';
  rsServerIPPort = 'Server IP Port :';
  rsUseTCPIPServ = 'Use TCP/IP Server';
  rsClientConnec = 'Client Connection Keep Alive';
  rsTelescopeSet = 'Telescope Setting';
  rsManualMount = 'Manual Mount';
  rsSetHowTheMou = 'Set how the mount move on each axis when you turn the '
    +'driving knob. Then the Telescope button show you the turns you must do '
    +'to go from one object to another.';
  rsRightAscensi = 'Right Ascension';
  rsDeclination = 'Declination';
  rsTurnsHour = 'turns / hour';
  rsTurnsDegree = 'turns / degree';
  rsRevertRAKnob = 'Reverse RA knob';
  rsRevertDECKno = 'Reverse DEC knob';
  rsRevertAzKnob = 'Reverse Az knob';
  rsRevertAltKno = 'Reverse Alt knob';
  rsCDCPluginSet = 'CDC plugin setting';
  rsTelescopePlu = 'Telescope Plugin ';
  rsINDIDriverSe = 'INDI Driver setting';
  rsINDIServerHo = 'INDI Server Host ';
  rsINDIServerPo = 'INDI server Port';
  rsServerComman = 'Server command ';
  rsDriverName = 'Driver name';
  rsTelescopeTyp = 'Telescope type';
  rsDevicePort = 'Device Port ';
  rsControlPanel2 = 'Control Panel command ';
  rsAutomaticall = 'Automatically start a local server if not already running';
  rsAlsoBeSureTh = '%sAlso be sure the require database software is '
    +'installed.%sPlease consult the documentation if you are unsure.%sDo you '
    +'want to continue?';
  rsWarningYouAr = 'Warning!%sYou are about to destroy the database %s and '
    +'all it''s content, even if this content is not related to this program.%'
    +'sAre you sure you want to continue?';
  rsTime = 'Time';
  rsSeconds = 'Seconds';
  rsAutoRefreshE = 'Auto-refresh every ';
  rsDTUT = 'DT - UT  : ';
  rsDynamicTimeD = 'Dynamic Time difference with Universal Time';
  rsUseAnotherDT = 'Use another DT-UT value';
  rsSHour = 'H';
  rsSMinute = 'M';
  rsSSecond = 'S';
  rsSYear = 'Y';
  rsSMonth = 'M';
  rsSDay = 'D';
  rsJD = 'JD:';
  rsActualSystem = 'Actual system time';
  rsUseSystemTim = 'Use system time';
  rsSimulation = 'Simulation';
  rsEvery = 'every ';
  rsNumberOfStep = 'Number of steps';
  rsPlotThePosit = 'Plot the position of moving object.';
  rsStepUnit = 'Step unit';
  rsConnectionLi = 'Connection lines between each position';
  rsAll = 'All';
  rsNone1 = 'None';
  rsZoom = 'Zoom +';
  rsZoom2 = 'Zoom -';
  rsAbort = 'Abort';
  rsAddLabel = 'Add Label';
  rsPrepareACata = 'Prepare a catalog CatGen';
  rsComputeField = 'Compute Field';
  rsChart_ = 'Chart_';
  rsCharts = 'Charts';
  rsDetails = 'Details';
  rsInfo = 'Information';
  rsPrintChart = 'Print Chart';
  rsProgress = 'Progress';
  rsExiting = 'Exiting ...';
  rsErrorPleaseC3 = 'Error! Please check the database parameters and load the '
    +'picture package.';
  rsMoreThanObje = 'More than %s objects, result truncated.';
  rsThereAreObjec = 'There are %s objects in this field.';
  rsEditLabel = 'Edit Label';
  rsEquatorialCo3 = 'Equatorial Coord.';
  rsAltAZCoord2 = 'Alt/AZ Coord.';
  rsEclipticCoor3 = 'Ecliptic Coord.';
  rsInclination2 = 'Inclination=';
  rsMag = 'Mag:';
  rsFOV2 = 'FOV:';
  rsConnectToSuc = 'Connect to %s, %s successful.%s';
  rsConnectToFai = 'Connect to %s, %s failed! %sVerify if the MySQL Server is '
    +'running and control the Userid/Password';
  rsDatabaseOpen = '%sDatabase %s opened.%s';
  rsCannotOpenDa = '%sCannot open database %s! %s';
  rsTableExist = '%sTable exist %s';
  rsTableDoNotEx = '%sTable %s do not exist! %sPlease correct the error and '
    +'retry.';
  rsAllTablesStr = '%sAll tables structure exists.';
  rsSQLDatabaseS = 'SQL database software is probably not installed!';
  rsErrorCreatin = '%sError creating table %s';
  rsFileNotFound = 'File not found!';
  rsProcessingLi = 'Processing line %s';
  rsInsertFailed = 'insert failed line %s : %s';
  rsProcessingEn = 'Processing ended. Total number of comet :%s';
  rsDeleteFromEl = 'Delete from element table...';
  rsFailed = 'Failed : %s';
  rsDeleteDailyD = 'Delete daily data';
  rsDeleteComple = 'Delete completed';
  rsDeleteFromEl2 = 'Delete from element list...';
  rsDeleteFromNa = 'Delete from name list...';
  rsInsertFailed2 = 'Insert failed! %s';
  rsThisFileWasN = 'This file was not recognized as a MPCORB file.';
  rsDataStartOnL = 'Data start on line %s';
  rsInvalidEpoch = 'invalid epoch on line%s : %s';
  rsMoreThan1000 = 'More than 1000 errors! Process aborted.';
  rsProcessingEn2 = 'Processing ended. Total number of asteroid :%s';
  rsDeleteFromMo = 'Delete from monthly table...';
  rsDeleteFromMo2 = 'Delete from monthly table for jd<%s';
  rsDBInsertFail = 'DB insert failed for %s :%s';
  rsInvalidFITSF = 'Invalid FITS file: %s';
  rsProcessingEn3 = 'Processing ended. Total number of location :%s';
  rsNotAFITSFile = 'Not a FITS file, SIMPLE = T keyword missing';
  rsClosingConne = 'Closing connection';
  rsEarthShadow = 'Earth shadow';
  rsBeginProcess = 'Begin processing for jd=%s / %s';
  rsDeletePrevio = 'Delete previous data for this date.';
  rsGetAsteroidL = 'Get Asteroid list.';
  rsEndProcessin = 'End processing: %s asteroids';
  rsProcessing = 'Processing... %s';
  rsMoveLabel = 'Move label';
  rsDefaultLabel = 'Default label';
  rsHideLabel = 'Hide label';
  rsErrorOpening = 'Error opening %s';
  rsLanguage2 = 'Language';
  rsLanguageSele = 'Language selection';
  rsMoreStars = 'More Stars';
  rsLessStars = 'Less Stars';
  rsMoreNebulae = 'More Deep Sky';
  rsLessNebulae = 'Less Deep Sky';
  rsTimeUnits = 'Time Units';
  rsSetFOVTo = 'Set FOV to';
  rsOtherLinesCa = 'Other Lines Catalogs';
  rsNebulaCommon = 'Deep Sky Common Name';
  rsStarCommonNa = 'Star Common Name';
  rsCommonName = 'Common Name';
  rsPostscript = 'Postscript';
  rsBitmap = 'Bitmap';
  rsColorLineMod = 'Color, Line mode';
  rsBlackWhiteLi = 'Black/White, Line mode';
  rsAsOnScreenBl = 'As on screen (black background!)';
  rsPortrait = 'Portrait';
  rsLandscape = 'Landscape';
  rsSystemPrinte = 'System Printer';
  rsBitmapFile = 'Bitmap File';
  rsMeanPosition = 'Mean position';
  rsTruePosition = 'True position';
  rsAzimuthalCoo = 'Azimuthal Coordinate';
  rsLineMode = 'Line mode';
  rsGraphic = 'Graphic';
  rsPhotographic2 = 'Photographic';
  rsParametric = 'Parametric';
  rsRed = 'Red';
  rsWhiteOnBlack = 'White on Black';
  rsBlackOnWhite = 'Black on White';
  rsNormalColor = 'Normal (color)';
  rsBlue = 'Blue';
  rsGreen = 'Green';
  rsFixedBlack = 'Fixed Black';
  rsFullName = 'Full Name';
  rsAbbreviation = 'Abbreviation';
  rsGeocentric = 'Geocentric';
  rsTopoCentric = 'TopoCentric';
  rsLineModeDraw = 'Line mode drawing';
  rsRealisticsIm = 'Realistic images';
  rsSymbol = 'Symbol';
  rsDisplayAsASy = 'Display as a symbol';
  rsProportional = 'Proportional to the tail length';
  rsProportional2 = 'Proportional to the magnitude';
  rsEquatorialMo = 'Equatorial Mount';
  rsAltAzMount = 'Alt/Az Mount';
  rsNebulaeOrOth = 'Deep Sky or other objects';
  rsNebulaeOutli = 'Nebulae outlines';
  rsBinaryIndexe = 'Binary indexed catalog';
  rsTextFileCata = 'Text file catalog';
  rsHoursMinutes = 'Hours, minutes, secondes';
  rsDecimalHours = 'Decimal hours';
  rsDegreesMinut = 'Degrees, minutes, secondes';
  rsDecimalDegre = 'Decimal degrees';
  rsDecimalSouth = 'Decimal South Polar Distance';
  rsSpline = 'Spline';
  rs50Recommende = '50   (recommended up to 100''000 objects)';
  rs184Recommend = '184 (recommended up to 1''000''000 objects)';
  rs732Recommend = '732 (recommended up to 5''000''000 objects)';
  rs9537LargerDa = '9537 (larger dataset)';
  rsMonday = 'Mon.';
  rsTuesday = 'Tue.';
  rsWednesday = 'Wed.';
  rsThursday = 'Thu.';
  rsFriday = 'Fri.';
  rsSaturday = 'Sat.';
  rsSunday = 'Sun.';
  rsJulianDay = 'Julian Day =';
  rsToday = 'Today';
  rsJDCalendar = 'JD calendar';
  rsWarningTheCu = 'Warning! The current date and the observatory location '
    +'may have changed from the default value. You must reply No and use the %'
    +'s button now to return to your default values, otherwise they may be '
    +'lost. Do you want to continue ?';
  rsCoordinates = 'Coordinates:';
  rsPleaseReport = 'Please report any problem to:';
  rsProgrammer ='Programmer:';
  rsTranslator ='Translator:';
  rsCDCTranslator ='CDCTranslator';
  rsAuthors = 'Authors';
  rsLicenseAgree = 'License Agreement';
  rsPlutoIsAPlan = 'Pluto is a planet.';
  rsUncheckToAvo = 'Uncheck to avoid duplicate with minor planet 134340';
  rsDirectoryNot = 'Directory not found %s';
  rsXplanetRetur = '%s, xplanet return %s';
  rsXplanetIsNot = 'Xplanet is not compiled with JPEG support';
  rsRequireXplan = '(require Xplanet 1.2.0)';
  rsXplanetIsPro = 'Xplanet is probably not installed!';
  rsEveryPositio = 'Every position';
  rsOneOfTwo = 'One of two';
  rsOneOfThree = 'One of three';
  rsOnlyTheFirst = 'Only the first';
  rsOnlyTheLast = 'Only the last';
  rsLabelText = 'Label Text';
  rsCurrentDate = 'Current Date';
  rsFillWithHori = 'Fill with horizon color';
  rsAD = 'AD';
  rsBC = 'BC';
  rsSelectTheTel = 'Select the telescope interface';
  rsINDIDriver = 'INDI Driver';
  rsCDCPlugin = 'CDC plugin';
  rsNonVisibleSe = 'Non visible search result, zoom for more details';
  rsNoPrinterFou = 'No Printer found!';
  rsShowGrid = 'Show Grid';
  rsCompassRoseS = 'Compass rose size';
  rsAlwaysShowCo = 'Always show compass rose';
  rsProgramInfor = 'Program Information';
  rsCountryTimez = 'Country Timezone';
  rsMoreOptions = 'More Options';
  rsWarningYouAr2 = 'Warning! you are using multiple catalog for the same '
    +'object. Be sure this what you want.';
  rsReleaseNotes = 'Release Notes';
  rsBlinkingPict = 'Blinking Picture';
  rsLatinName = 'Latin Name';
  rsExpertMode = 'Expert mode';
  rsTypeOfCoordi = 'Type of coordinates';
  rsApparent = 'Apparent';
  rsMeanOfTheDat = 'Mean of the date';
  rsMeanJ2000 = 'Mean J2000';
  rsMean = 'Mean';
  rsNoProperMo = ', no proper motion';
  rsAstrometricJ = 'Astrometric J2000';
  rsTrueEquatorE = 'true equator, equinox and epoch of the date';
  rsMeanEquatorE = 'mean equator, equinox and epoch of the date';
  rsMeanEquinoxA = 'mean equinox and epoch J2000';
  rsMeanEquinoxJ = 'mean equinox J2000, epoch of the date';
  rsEpoch = 'Epoch';
  rsAlignment = 'Alignment';
  rsCenter = 'Center';
  rsRequestTimeo = 'Request timeout. You probably asked a too width area that '
    +'request too much processing time on the remote server.';
  rsUnableToCrea = 'Unable to create directory ';
  rsPleaseTryToC = 'Please try to create this directory yourself and restart '
    +'the program.';
  rsCouldNotLoad = 'Could not load library ';
  rsPleaseTryToR = 'Please try to reinstall the program.';
  rsSomethingGoW = 'Something go wrong during program initialization. We must '
    +'now close';
  rsStopTCPIPSer = 'Stop TCP/IP server';
  rsDateFormat = 'Date Format';
  rsFixedSkyColo = 'Fixed sky color';
  rsProperMotion3 = 'Proper Motion';
  rsGetRecentMea = 'Get recent measurement from JUPOS project';
  rsReduceDetail = 'Reduce detail when moving the chart';
  rsVariableStar2 = 'Variable Stars';
  rsAllConfigura = 'All configuration options';
  rsAskConfirmat = 'Ask confirmation before any Internet connection';
  rsNumberOfNebu = 'Number of nebulae';
  rsInformationD = 'Information detail';
  rsDisplayLabel = 'Display labels for all star catalog';
  rsUsingExistin = 'Using existing file %s';
  rsSideral = 'Sideral';
  rsBrightStarsS = 'Bright Stars Size';
  rsLegal = 'Legal';
  rsMeanLocal = 'Mean local';
  rsJD2 = 'JD';
  rsClock = 'Clock';

implementation

procedure GetDefaultLanguage(var buf1,buf2: string);
var i : integer;
begin
 GetLanguageIDs(buf1,buf2);
 i:=pos('.',buf1);
 if i>0 then buf1:=copy(buf1,1,i-1);
end;

function Translate(lang : string = ''):string;
var lang2,pofile: string;
begin
 lang2:='';
 if lang='' then GetDefaultLanguage(lang,lang2);
 writetrace('Try language: '+lang+', '+lang2);
 pofile:=format(slash(appdir)+slash('data')+slash('language')+'skychart.%s.po',[lang]);
 if FileExists(pofile) then result:=lang
 else begin
    pofile:=format(slash(appdir)+slash('data')+slash('language')+'skychart.%s.po',[lang2]);
    if FileExists(pofile) then result:=lang2
    else begin
        pofile:=format(slash(appdir)+slash('data')+slash('language')+'skychart.%s.po',['en']);
        result:='en';
    end;
 end;
 // translate CDC messages
 TranslateUnitResourceStrings('u_translation',slash(appdir)+slash('data')+slash('language')+'skychart.%s.po',result,'');
 // translate LCL messages
 TranslateUnitResourceStrings('LCLStrConsts',slash(appdir)+slash('data')+slash('language')+'lclstrconsts.%s.po',result,'');
 writetrace('Language: '+result+' '+rsLanguage);
end;

end.

